/* cknight.pdb  AP  04-jan-89 */
/* knighter's tour */

?- reconsult( graphic ).

generate(X) :- LeftCornerX is 40 - 2 * X,
               LeftCornerY is 11 - X,
               assert(topleft(LeftCornerX,LeftCornerY)),
               MaxSteps is X * X,
               assert(maxsteps(MaxSteps)),
               genx(X,X).                     /* (X * X) - Feld generieren */

genx(0,_).
genx(X,Y) :- geny(X,Y), 
             X1 is X - 1,
             genx(X1,Y).

geny(_,0).
geny(X,Y) :- /* not(field(X,Y)),*/
             assert(field(X,Y)),
             writex(X,Y),
             Y1 is Y - 1,
             geny(X,Y1).
geny(X,Y) :- Y1 is Y - 1,
             geny(X,Y1).

add(X,[],[X]).
add(X,Y,[X|Y]).

is_in(X,[X|_]).
is_in(X,[_|Z]) :- is_in(X,Z).

setpos(X,Y) :- Z is (X + Y) mod 2,
               Z = 0,!, 
               backg(yellow),
               topleft(Tx,Ty),
               X1 is Tx + 6 * (X - 1),
               Y1 is Ty + 3 * (Y - 1),
               cpos(Y1,X1), !.

setpos(X,Y) :- backg(black),
               topleft(Tx,Ty),
               X1 is Tx + 6 * (X - 1),
               Y1 is Ty + 3 * (Y - 1),
               cpos(Y1,X1), !.

writex(X,Y) :- setpos(X,Y), cbw, cbw, write('      '),
               setpos(X,Y), cbw, cbw, cup, write('      '),
               setpos(X,Y), cbw, cbw, cdown, write('      '), !.

writen(X,Y) :- setpos(X,Y), write('*').
writen(X,Y) :- setpos(X,Y), write(' '), !, fail.

writeo(X,Y) :- setpos(X,Y), write('.').
writeo(X,Y) :- setpos(X,Y), write('*'), !, fail.



try(pos(X,Y),L,Len) :-
        X1 is X + 1, Y1 is Y + 2,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(X,Y),L,Len) :-
        X1 is X + 2, Y1 is Y + 1,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(X,Y),L,Len) :-
        X1 is X + 2, Y1 is Y - 1,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(X,Y),L,Len) :-
        X1 is X + 1, Y1 is Y - 2,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(X,Y),L,Len) :-
        X1 is X - 1, Y1 is Y - 2,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(X,Y),L,Len) :-
        X1 is X - 2, Y1 is Y - 1,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(X,Y),L,Len) :-
        X1 is X - 2, Y1 is Y + 1,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(X,Y),L,Len) :-
        X1 is X - 1, Y1 is Y + 2,
        field(X1,Y1), not(is_in(pos(X1,Y1),L)),
        writeo(X,Y), writen(X1,Y1), Len1 is Len + 1,
        add(pos(X1,Y1),L,L1), try(pos(X1,Y1),L1,Len1).

try(pos(_,_),_,Len) :-
                   maxsteps(Len),        /* Abbruchbedingung */
                   cpos(22,1),
                   charattr(off),
                   foreg(yellow),
                   backg(blue).            

knight :- charattr(off), backg(white), foreg(blue),
          chome, clears,
          write('  springer tour :  enter brettgrsse : '),
          read(Size), nl,
          write('                   enter startposition (X, Y) : '),
          read(X), read(Y), nl,
          X =< Size, Y =< Size,
          retractall(field),
          retractall(maxsteps),
          retractall(topleft),
          foreg(red),
          generate(Size),
          writen(X,Y), !,
          try(pos(X,Y),[pos(X,Y)],1).

/* aus graphic.pdb */
/*
cpos(X,Y) :- put(27),put(91),!,
             cposx(X),
             put(59),!,
             cposx(Y),put(72),!.

cposx(X) :- X < 9, Y is X + 48, put(Y).
cposx(X) :- Y1 is X mod 10, 
            Y11 is X - Y1,
            Z is Y11 / 10 + 48,
            Z1 is Y1 + 48,
            put(Z),put(Z1).

chome :- put(27),put(91),put(72),!.

cup :- put(27),put(91),put(49),put(65),!.

cdown :- put(27),put(91),put(49),put(66),!.

cbw :- put(27),put(91),put(49),put(68),!.

cls :- put(27),put(91),put(74),!.

charattr(off) :- put(27),put(91),put(48),put(109),!.
*/
backg(black) :-   put(27),write('[40m'),!.
backg(yellow) :-  put(27),write('[43m'),!.
backg(white) :-   put(27),write('[47m'),!.
backg(blue) :-    put(27),write('[44m'),!.

foreg(red) :-     put(27),write('[31m'),!.
foreg(yellow) :-  put(27),write('[33m'),!.
foreg(blue) :-    put(27),write('[34m'),!.
